import { UploadStatisticsDto, StorageStatisticsSegmentDto } from "@upload-io/upload-shared-iso";
import { IsoObjectUtils } from "@upload-io/upload-shared-iso/common/IsoObjectUtils";

export interface StorageStatisticsDto {
  caches: {
    [cacheId: string]: StorageStatisticsSegmentDto | undefined;
  };
  uploads: UploadStatisticsDto;
}

export interface StorageStatisticsUnboxedDto {
  caches: {
    [cacheId: string]: StorageStatisticsSegmentDto | null;
  };
  uploads: UploadStatisticsDto;
}

export namespace StorageStatisticsDto {
  export const empty: StorageStatisticsDto = {
    caches: {},
    uploads: UploadStatisticsDto.empty
  };

  export function combine(left: StorageStatisticsDto, right: StorageStatisticsDto): StorageStatisticsDto {
    return {
      uploads: UploadStatisticsDto.combine(left.uploads, right.uploads),
      caches: IsoObjectUtils.fullOuterJoin(left.caches, right.caches, StorageStatisticsSegmentDto.combine)
    };
  }
}
